package org.ts.ddcs.DataItemTemplate;

import org.ts.ddcs.Entity.RtuStatusEntity;
import org.ts.ddcs.log.LogHelper;
import org.ts.ddcs.Tool.BytesHelp;


/**
 * funcode ff52
 * RTU温度
 */
@SuppressWarnings("all")
public class DataItemTemplateFF52 extends DataItemTemplate {

    @Override
    public byte[] Stream(byte[] data) {
        byte[] remain = data;
        if (this.macth) {
            return remain;
        }
        int count = 0;
        String flag = BytesHelp.byte2HexStr(remain, count, 2);
        count += 2;
        if (flag.equals(this.feture)) {
            byte[] len = BytesHelp.subBytes(remain, count, 1);
            count += 1;
            int dataTotalLen = len[0] >> 3;
            int decimalLen = len[0] & 7;
            byte[] buff = BytesHelp.subBytes(remain, count, dataTotalLen);
            boolean dataError = true;
            for (int i = 0; i < buff.length; i++) {
                if (buff[i] != (byte) 0xFF) {
                    dataError = false;
                    break;
                }
            }
            count += dataTotalLen;
            String hexStr = BytesHelp.byte2HexStr(buff);
            if (!dataError) {
                this.bigDecimalValue = BytesHelp.toDecimal(hexStr, decimalLen);
            } else {
                LogHelper.info(this.desc + ":" + this.feture + ":" + "数据异常 " + hexStr);
            }
            remain = BytesHelp.subBytes(remain, count, remain.length - count);
            this.macth = true;
        }
        return remain;
    }

    @Override
    public void SetEntity(Object entity) {
        RtuStatusEntity statusEntity = (RtuStatusEntity) entity;
        statusEntity.setTemperature(this.bigDecimalValue);
    }
}
